format PE GUI 4.0
entry Start

include '%finc%/win32/win32a.inc'

include '%lib%/simpledebug/debug.asm'

options.DebugMode = 1


uglobal
  hInstance dd ?
  hHeap     dd ?
  hMainForm dd ?
  hPopup    dd ?

  msg MSG
endg

iglobal
  cWindowClassName du 'MyWinClass', 0
  cMainWinCaption du "Should be active, after popup show.", 0

endg


initialize __RegisterWindowClass

.wc WNDCLASS

begin
        xor     eax, eax
        lea     edi, [.wc]
        mov     ecx, sizeof.WNDCLASS / 4
        rep stosd

        mov     [.wc.style], CS_OWNDC or CS_DBLCLKS or CS_VREDRAW or CS_HREDRAW
        mov     [.wc.lpfnWndProc], __CommonWindowProc
        mov     [.wc.cbWndExtra], 32

        mov     eax,[hInstance]
        mov     [.wc.hInstance],eax
        mov     [.wc.lpszClassName], cWindowClassName

        lea     eax, [.wc]
        invoke  RegisterClassW, eax

        return
endp



proc __CommonWindowProc, .hwnd, .wmsg, .wparam, .lparam
.ps PAINTSTRUCT
begin
        cmp     [.wmsg], WM_DESTROY
        je      .quit

        cmp     [.wmsg], WM_SETFOCUS
        je      .set_focus

        cmp     [.wmsg], WM_KILLFOCUS
        je      .kill_focus

        cmp     [.wmsg], WM_PAINT
        je      .paint


.ondefault:
        invoke  DefWindowProcW, [.hwnd], [.wmsg], [.wparam], [.lparam]
        return

.quit:
        invoke  PostQuitMessage, 0
        jmp     .ondefault

.set_focus:
        OutputValue "Set focus:", [.hwnd], 16, 8
        jmp      .ondefault

.kill_focus:
        OutputValue "Kill focus:", [.hwnd], 16, 8
        jmp      .ondefault

.paint:
        lea     eax, [.ps]
        invoke  BeginPaint, [.hwnd], eax

        mov     eax, $0000ff
        mov     ecx, [.hwnd]

        cmp     ecx, [hPopup]
        je      .brush

        mov     eax, $ff0080

.brush:
        invoke  CreateSolidBrush, eax
        push    eax
        mov     ecx, eax

        lea     eax, [.ps.rcPaint]
        invoke  FillRect, [.ps.hdc], eax, ecx

        invoke  DeleteObject ; from the stack

        lea     eax, [.ps]
        invoke  EndPaint, [.hwnd], eax

        xor     eax, eax
        return

endp





Start:
        invoke  GetModuleHandleA,0
        mov     [hInstance],eax
        invoke  GetProcessHeap
        mov     [hHeap], eax

        InitializeAll

        DebugMsg "WINE WS_POPUP test"

        invoke  CreateWindowExW, WS_EX_APPWINDOW, cWindowClassName, cMainWinCaption, WS_OVERLAPPEDWINDOW, 200, 400, 320, 240, 0, 0, [hInstance], 0
        mov     [hMainForm], eax

        OutputValue "Main window:", eax, 16, 8

        invoke  CreateWindowExW, 0, cWindowClassName, 0, 0, 0, 0, 0, 0, 0, 0, [hInstance], 0
        mov     [hPopup], eax

        OutputValue "Popup window:", eax, 16, 8

        invoke  SetWindowLongW, [hPopup], GWL_HWNDPARENT, [hMainForm]
        invoke  SetWindowLongW, [hPopup], GWL_STYLE, WS_POPUP
        invoke  SetWindowLongW, [hPopup], GWL_EXSTYLE, WS_EX_TOOLWINDOW
        invoke  SetWindowPos, [hPopup], 0, 220, 420, 160, 320, SWP_NOZORDER or SWP_NOACTIVATE; or SWP_SHOWWINDOW or SWP_NOACTIVATE

        invoke  ShowWindow, [hMainForm], SW_SHOWNORMAL
        invoke  ShowWindow, [hPopup], SW_SHOWNOACTIVATE

.msgloop:
        xor     eax, eax
        invoke  PeekMessageW, msg, eax, eax, eax, PM_REMOVE
        test    eax, eax
        jz      .wait

        cmp     [msg.message], WM_QUIT
        je      .terminate

        invoke  TranslateMessage, msg
        invoke  DispatchMessageW, msg
        jmp     .msgloop

.wait:
        invoke  WaitMessage
        jmp     .msgloop


.terminate:
        push    eax
        FinalizeAll
        invoke  ExitProcess ; exit code from the stack.

data import
  include '%finc%/win32/allimports.asm'
end data

IncludeAllGlobals
